#include "../math.hpp"

#include "../vector/vector.hpp"
#include "../vector/vector2.hpp"
#include "../vector/vector3.hpp"
#include "../vector/vector4.hpp"
#include "../vector/matrix.hpp"
#include "../vector/matrix2.hpp"
#include "../vector/matrix3.hpp"
#include "../vector/matrix4.hpp"

#include<cmath>
#include<cstdlib>
#include<iostream>

int main(){
	using namespace std;
	
	typedef tempest::vector<double,3> V3;
	
	double a = 0.5;
	double temp;
	
	cout <<"normal: "<<1/a<< endl;	
	temp = 1;
	for(int i = 0;i<5;i++){
		temp = tempest::newton_rcp(a,temp);
		cout <<"newton: "<<temp<< endl;
	}
	cout << "----------------" << endl;
	
	cout <<"normal: "<<1/sqrt(a)<< endl;
	temp = 1/a;
	for(int i = 0;i<5;i++){
		temp = tempest::newton_rsqrt(a,temp);
		cout <<"newton: "<<temp<< endl;
	}
	
	srand(time(0));
	V3 va[100];
	V3 vb[100];
	for(int i = 0;i<100;i++){
		vb[i] = va[i] = V3(rand()%30,rand()%30,rand()%30);
	}
	
	for(int i = 0;i<100;i++){
		cout <<va[i].normalize()<<endl;
		
		double length = vb[i].sqr_length();
		temp = 1/length;
		for(int x = 0;x<15;x++){
			temp = tempest::newton_rsqrt(length,temp);
		}
		cout <<vb[i]*temp<<endl<<endl;
		
	}
	
	
	return 0;
}


