#include"../vector/vector.hpp"
#include"../vector/vector2.hpp"
#include"../vector/vector3.hpp"
#include"../vector/vector4.hpp"
#include"../vector/et_vector.hpp"

#include <iostream>


int main(){
	typedef tempest::vector<double, 2> VECTOR2;
	typedef tempest::vector<long int, 2> LVECTOR2;
	
	typedef tempest::vector<double, 3> VECTOR3;
	typedef tempest::vector<long int, 3> LVECTOR3;
	
	typedef tempest::vector<double, 4> VECTOR4;
	typedef tempest::vector<long int, 4> LVECTOR4;
	
	typedef tempest::vector<double, 5> VECTOR5;
	typedef tempest::vector<long int, 5> LVECTOR5;
	{
		VECTOR2 v1(1,2),v2(3.3,4.4);
		LVECTOR2 v3(1,2);	
	
		std::cout << v1 << "," << v2 << std::endl;
		std::cout << v1 + v2 << std::endl; 
	
		std::cout << et(v3) << "," << et(v2) << std::endl;
		std::cout << et(v3) + et(v2) << std::endl;
		std::cout << std::endl;
	}
	{
		using tempest::et;
		VECTOR3 v1(1,2,3),v2(3.3,4.4,5.5);
		LVECTOR3 v3(1,2,3);	
	
		std::cout << v1 << "," << v2 << std::endl;
		std::cout << v1 + v2 << std::endl; 
	
		std::cout << et(v3) << "," << et(v2) << std::endl;
		std::cout << et(v3) + et(v2)*et(2.0f)  << std::endl;
		//std::cout << tempest::et(2)<< std::endl;
		std::cout << std::endl;
	}
	{
		VECTOR4 v1(1,2,3,4),v2(3.3,4.4,5.5,6.6);
		LVECTOR4 v3(1,2,3,4);
		
		std::cout << v1 << "," << v2 << std::endl;
		std::cout << v1 + v2 << std::endl; 
	
		std::cout << et(v3) << "," << et(v2) << std::endl;
		std::cout << et(v3) + et(v2) << std::endl; 
		std::cout << std::endl;
	
	}
	{
		VECTOR5 v1,v2;
		LVECTOR5 v3;
		for(int i = 0;i < 5;i++){
			v1[i] = v3[i] = i+1;
			v2[i] = (i+1 + 2)*1.1;
		}
		
		std::cout << v1 << "," << v2 << std::endl;
		std::cout << v1 + v2 << std::endl; 
	
		std::cout << et(v3) << "," << et(v2) << std::endl;
		std::cout << et(v3) + et(v2) << std::endl; 
		std::cout << std::endl;
	
	}
}




